// Code generated by MockGen. DO NOT EDIT.
// Source: interfaces.go
//
// Generated by this command:
//
//	mockgen -source interfaces.go
//
// Package mock_app is a generated GoMock package.
package app

import (
	context "context"
	reflect "reflect"
	domain "user-service/internal/domain"

	gomock "go.uber.org/mock/gomock"
)

// MockUserStore is a mock of UserStore interface.
type MockUserStore struct {
	ctrl     *gomock.Controller
	recorder *MockUserStoreMockRecorder
}

// MockUserStoreMockRecorder is the mock recorder for MockUserStore.
type MockUserStoreMockRecorder struct {
	mock *MockUserStore
}

// NewMockUserStore creates a new mock instance.
func NewMockUserStore(ctrl *gomock.Controller) *MockUserStore {
	mock := &MockUserStore{ctrl: ctrl}
	mock.recorder = &MockUserStoreMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockUserStore) EXPECT() *MockUserStoreMockRecorder {
	return m.recorder
}

// AddUser mocks base method.
func (m *MockUserStore) AddUser(ctx context.Context, attrs domain.UserAttrs) (domain.UserId, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "AddUser", ctx, attrs)
	ret0, _ := ret[0].(domain.UserId)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// AddUser indicates an expected call of AddUser.
func (mr *MockUserStoreMockRecorder) AddUser(ctx, attrs any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "AddUser", reflect.TypeOf((*MockUserStore)(nil).AddUser), ctx, attrs)
}

// GetUsers mocks base method.
func (m *MockUserStore) GetUsers(ctx context.Context, cr domain.UserCriteria) ([]domain.User, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetUsers", ctx, cr)
	ret0, _ := ret[0].([]domain.User)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetUsers indicates an expected call of GetUsers.
func (mr *MockUserStoreMockRecorder) GetUsers(ctx, cr any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetUsers", reflect.TypeOf((*MockUserStore)(nil).GetUsers), ctx, cr)
}

// RemoveUser mocks base method.
func (m *MockUserStore) RemoveUser(ctx context.Context, userId string) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RemoveUser", ctx, userId)
	ret0, _ := ret[0].(error)
	return ret0
}

// RemoveUser indicates an expected call of RemoveUser.
func (mr *MockUserStoreMockRecorder) RemoveUser(ctx, userId any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RemoveUser", reflect.TypeOf((*MockUserStore)(nil).RemoveUser), ctx, userId)
}

// UpdateUser mocks base method.
func (m *MockUserStore) UpdateUser(ctx context.Context, userId domain.UserId, attrs domain.UserAttrs) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "UpdateUser", ctx, userId, attrs)
	ret0, _ := ret[0].(error)
	return ret0
}

// UpdateUser indicates an expected call of UpdateUser.
func (mr *MockUserStoreMockRecorder) UpdateUser(ctx, userId, attrs any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "UpdateUser", reflect.TypeOf((*MockUserStore)(nil).UpdateUser), ctx, userId, attrs)
}

// MockUserNotifier is a mock of UserNotifier interface.
type MockUserNotifier struct {
	ctrl     *gomock.Controller
	recorder *MockUserNotifierMockRecorder
}

// MockUserNotifierMockRecorder is the mock recorder for MockUserNotifier.
type MockUserNotifierMockRecorder struct {
	mock *MockUserNotifier
}

// NewMockUserNotifier creates a new mock instance.
func NewMockUserNotifier(ctrl *gomock.Controller) *MockUserNotifier {
	mock := &MockUserNotifier{ctrl: ctrl}
	mock.recorder = &MockUserNotifierMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockUserNotifier) EXPECT() *MockUserNotifierMockRecorder {
	return m.recorder
}

// Notify mocks base method.
func (m *MockUserNotifier) Notify(notification domain.UserNotification) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Notify", notification)
	ret0, _ := ret[0].(error)
	return ret0
}

// Notify indicates an expected call of Notify.
func (mr *MockUserNotifierMockRecorder) Notify(notification any) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Notify", reflect.TypeOf((*MockUserNotifier)(nil).Notify), notification)
}

// MockUserNotificationReader is a mock of UserNotificationReader interface.
type MockUserNotificationReader struct {
	ctrl     *gomock.Controller
	recorder *MockUserNotificationReaderMockRecorder
}

// MockUserNotificationReaderMockRecorder is the mock recorder for MockUserNotificationReader.
type MockUserNotificationReaderMockRecorder struct {
	mock *MockUserNotificationReader
}

// NewMockUserNotificationReader creates a new mock instance.
func NewMockUserNotificationReader(ctrl *gomock.Controller) *MockUserNotificationReader {
	mock := &MockUserNotificationReader{ctrl: ctrl}
	mock.recorder = &MockUserNotificationReaderMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockUserNotificationReader) EXPECT() *MockUserNotificationReaderMockRecorder {
	return m.recorder
}

// GetNotifications mocks base method.
func (m *MockUserNotificationReader) GetNotifications() (<-chan domain.UserNotification, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetNotifications")
	ret0, _ := ret[0].(<-chan domain.UserNotification)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetNotifications indicates an expected call of GetNotifications.
func (mr *MockUserNotificationReaderMockRecorder) GetNotifications() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetNotifications", reflect.TypeOf((*MockUserNotificationReader)(nil).GetNotifications))
}
